using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace Sword
{
    public class SwordBehaviour : MonoBehaviour
    {
       private void Start()
       {
           this.renderer = gameObject.GetComponent<SpriteRenderer>();
           UpdateState();
       }
       void UpdateState()
       {
           if(this.Activated)
           {
               renderer.sprite = B;
               renderer.sortingLayerName = "Bottom";
               gameObject.layer = 1;
           }
           else
           {
               renderer.sprite = A;
               renderer.sortingLayerName = "Objects";
               gameObject.layer = LayerMask.NameToLayer("Objects");
           }
       }
       private void Use() {
         if (!base.enabled) {
            return;
         }
         this.SetActivated(!this.Activated);
      }
      private void SetActivated(bool activated) {
         this.Activated = activated;
         UpdateState();
      }

      public bool Activated = false;
      [SkipSerialisation]
      public SpriteRenderer renderer;
      [SkipSerialisation]
      public Sprite A;
      [SkipSerialisation]
      public Sprite B;
   }
}