using UnityEngine;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
            CategoryBuilder.Create("Assasin's Creed Beta", "Assasin's Creed", ModAPI.LoadSprite("Assasin's Creed Beta.png"));

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Altair",
                    DescriptionOverride = "Flying, son of Nobody.",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("Altairr.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
                      var skin = ModAPI.LoadTexture("Altair.png");
                                 //get person
                                 var person = Instance.GetComponent<PersonBehaviour>();

                                 //use the helper function to set each texture
                                 //parameters are as follows:
                                 //  skin texture, flesh texture, bone texture, sprite scale
                                 //you can pass "null" to fall back to the original texture
                                 person.SetBodyTextures(skin, null, null, 1);

                                 //change procedural damage colours if they interfere with your texture (rgb 0-255)
                                 person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                                 person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                                 person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                                 person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                                 person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
               );                     
               ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Haytham",
                    DescriptionOverride = "first Grand Master of the Knights Templar in the American colonies.",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("HaythamA.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
                      var skin = ModAPI.LoadTexture("HaythamB.png");
                                 //get person
                                 var person = Instance.GetComponent<PersonBehaviour>();

                                 //use the helper function to set each texture
                                 //parameters are as follows:
                                 //  skin texture, flesh texture, bone texture, sprite scale
                                 //you can pass "null" to fall back to the original texture
                                 person.SetBodyTextures(skin, null, null, 1);

                                 //change procedural damage colours if they interfere with your texture (rgb 0-255)
                                 person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                                 person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                                 person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                                 person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                                 person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
               );                   
        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Lucy",
                    DescriptionOverride = "a secretly dispatched assassin, a spy at Abstergo Industries and a former genetic memory researcher in Abstergo.",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("LucyA.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
                      var skin = ModAPI.LoadTexture("LucyB.png");
                                 //get person
                                 var person = Instance.GetComponent<PersonBehaviour>();

                                 //use the helper function to set each texture
                                 //parameters are as follows:
                                 //  skin texture, flesh texture, bone texture, sprite scale
                                 //you can pass "null" to fall back to the original texture
                                 person.SetBodyTextures(skin, null, null, 1);

                                 //change procedural damage colours if they interfere with your texture (rgb 0-255)
                                 person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                                 person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                                 person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                                 person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                                 person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
               ); 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "William",
                    DescriptionOverride = "the leader of the Assassins in the present.",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("WilliamA.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
                      var skin = ModAPI.LoadTexture("WilliamB.png");
                                 //get person
                                 var person = Instance.GetComponent<PersonBehaviour>();

                                 //use the helper function to set each texture
                                 //parameters are as follows:
                                 //  skin texture, flesh texture, bone texture, sprite scale
                                 //you can pass "null" to fall back to the original texture
                                 person.SetBodyTextures(skin, null, null, 1);

                                 //change procedural damage colours if they interfere with your texture (rgb 0-255)
                                 person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                                 person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                                 person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                                 person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                                 person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
               ); 
          ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Rebecca",
                    DescriptionOverride = " member of the Order of the Assassins. Engineer.",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("RebeccaA.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
                      var skin = ModAPI.LoadTexture("RebeccaB.png");
                                 //get person
                                 var person = Instance.GetComponent<PersonBehaviour>();

                                 //use the helper function to set each texture
                                 //parameters are as follows:
                                 //  skin texture, flesh texture, bone texture, sprite scale
                                 //you can pass "null" to fall back to the original texture
                                 person.SetBodyTextures(skin, null, null, 1);

                                 //change procedural damage colours if they interfere with your texture (rgb 0-255)
                                 person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                                 person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                                 person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                                 person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                                 person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
             ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Sheam",
                    DescriptionOverride = "member of the Order of the Assassins. Sean provided tactical guidance to numerous Assassin teams around the world, mostly in dangerous field conditions. .",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("Sean A.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
                      var skin = ModAPI.LoadTexture("Sean B.png");
                                 //get person
                                 var person = Instance.GetComponent<PersonBehaviour>();

                                 //use the helper function to set each texture
                                 //parameters are as follows:
                                 //  skin texture, flesh texture, bone texture, sprite scale
                                 //you can pass "null" to fall back to the original texture
                                 person.SetBodyTextures(skin, null, null, 1);

                                 //change procedural damage colours if they interfere with your texture (rgb 0-255)
                                 person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                                 person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                                 person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                                 person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                                 person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
               ); 
          //Sword Tamp
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),
                    NameOverride = "Sword Tamp",
                    NameToOrderByOverride = "g",
                    DescriptionOverride = "Templar sword used by Shay Patrick Cormac.",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("Sword TampA.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sword TampB.png");
						Instance.FixColliders();
                    }
                }
            );
          //Apple Edem
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Apple Edem",
					NameToOrderByOverride = "i",
                    DescriptionOverride = "The Apple of Eden endowed with mighty power.",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("AppleEdem.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Apple.png");
                    }
                }
            );
  //Wind Pipe
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "Wind pipe",
                    NameToOrderByOverride = "h",
                    DescriptionOverride = "Windpipe Edward",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("Wind pipeA.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Wind pipe.png");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("Knockout Syringe");
						Instance.FixColliders();
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						firearm.AutomaticFireInterval = 0.17f;                                                 
                    }
                }
            );
 
      ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Desmond",
                    DescriptionOverride = "descendant of Altair ibn La Achad, Ezio Auditore da Firenze, Edward Kenway, Radunhageydu. ",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("DesmondA.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
                      var skin = ModAPI.LoadTexture("DesmondB.png");
                                 //get person
                                 var person = Instance.GetComponent<PersonBehaviour>();

                                 //use the helper function to set each texture
                                 //parameters are as follows:
                                 //  skin texture, flesh texture, bone texture, sprite scale
                                 //you can pass "null" to fall back to the original texture
                                 person.SetBodyTextures(skin, null, null, 1);

                                 //change procedural damage colours if they interfere with your texture (rgb 0-255)
                                 person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                                 person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                                 person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                                 person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                                 person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
//Pneumo Rifle Shey Kmock Knock.
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "Pneumo Rifle Shey Knock.",
                    NameToOrderByOverride = "h",
                    DescriptionOverride = "Pneumo Rifle Shey Knockout Syringe",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("Pneumo Rifle SheyA.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pneumo Rifle SheyB.png");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("Knockout Syringe");
						Instance.FixColliders();
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						firearm.AutomaticFireInterval = 0.17f;                                                 
                    }
                }
            );
       //Pneumo Rifle Shey Kmock Death
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "Pneumo Rifle Shey Death.",
                    NameToOrderByOverride = "h",
                    DescriptionOverride = "Pneumo Rifle Shey Syringe Death",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("Pneumo Rifle SheyE.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pneumo Rifle SheyF.png");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("Death Syringe");
						Instance.FixColliders();
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						firearm.AutomaticFireInterval = 0.17f;                                                 
                    }
                }
            );
        //Revolver
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Revolver"),
                    NameOverride = "Psistol with removable silencer",
                    NameToOrderByOverride = "Psistol with removable silencer witch assasin's creed 4",
                    DescriptionOverride = "a musket",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("RevolverA.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("RevolverB.png", 1f);
                        Instance.FixColliders();
                    }
                }
           );
          //Rifle Shey 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rifle"),
                    NameOverride = "Rifle Shey",
                    NameToOrderByOverride = "Rifle Shey ",
                    DescriptionOverride = "Firearm Musket Neck",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("Pneumo Rifle SheyC.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pneumo Rifle SheyD.png", 1f);
                        Instance.FixColliders();
                    }
                }
            );                         
          //Seno
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Wooden Pole"),
                    NameOverride = "Not soft",
                    NameToOrderByOverride = "k",
                    DescriptionOverride = "Not recommended for jumping from the 23rd floor.",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("SenoA.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SenoB.png");
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Concrete");
                        Instance.FixColliders();
                    }
                }
            );
                 //Psistol With Removable Silencer
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sniper Rifle"),
                    NameOverride = "Pistol with removable silencer",
                    NameToOrderByOverride = "Pistol with removable silencer witch assasin's creed 4",
                    DescriptionOverride = "a musket",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("Pistol with removable silencer a.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistol with removable silencer b.png", 1f);
                        Instance.FixColliders();
                    }
                }
            );                                                       
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Edward Kenway",
                    DescriptionOverride = "Thunderstorm of the Seas, Sword of God ",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("Edward Kenwayy.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
                      var skin = ModAPI.LoadTexture("Edward Kenway.png");
                                 //get person
                                 var person = Instance.GetComponent<PersonBehaviour>();

                                 //use the helper function to set each texture
                                 //parameters are as follows:
                                 //  skin texture, flesh texture, bone texture, sprite scale
                                 //you can pass "null" to fall back to the original texture
                                 person.SetBodyTextures(skin, null, null, 1);

                                 //change procedural damage colours if they interfere with your texture (rgb 0-255)
                                 person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                                 person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                                 person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                                 person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                                 person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
          ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Shey Kormok",
                    DescriptionOverride = "True Templar",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("SheyPatrick.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
                      var skin = ModAPI.LoadTexture("Patrick.png");
                                 //get person
                                 var person = Instance.GetComponent<PersonBehaviour>();

                                 //use the helper function to set each texture
                                 //parameters are as follows:
                                 //  skin texture, flesh texture, bone texture, sprite scale
                                 //you can pass "null" to fall back to the original texture
                                 person.SetBodyTextures(skin, null, null, 1);

                                 //change procedural damage colours if they interfere with your texture (rgb 0-255)
                                 person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                                 person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                                 person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                                 person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                                 person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Jacob Fray",
                    DescriptionOverride = "Brother Ivi",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("JacobA.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
                      var skin = ModAPI.LoadTexture("JacobB.png");
                                 //get person
                                 var person = Instance.GetComponent<PersonBehaviour>();

                                 //use the helper function to set each texture
                                 //parameters are as follows:
                                 //  skin texture, flesh texture, bone texture, sprite scale
                                 //you can pass "null" to fall back to the original texture
                                 person.SetBodyTextures(skin, null, null, 1);

                                 //change procedural damage colours if they interfere with your texture (rgb 0-255)
                                 person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                                 person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                                 person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                                 person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                                 person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Arno",
                    DescriptionOverride = "Father Killed by the True Templar  enemy",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("ArnoA.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
                      var skin = ModAPI.LoadTexture("ArnoB.png");
                                 //get person
                                 var person = Instance.GetComponent<PersonBehaviour>();

                                 //use the helper function to set each texture
                                 //parameters are as follows:
                                 //  skin texture, flesh texture, bone texture, sprite scale
                                 //you can pass "null" to fall back to the original texture
                                 person.SetBodyTextures(skin, null, null, 1);

                                 //change procedural damage colours if they interfere with your texture (rgb 0-255)
                                 person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                                 person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                                 person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                                 person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                                 person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
          );
           ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Eivor",
                    DescriptionOverride = "A real Viking, but not an assassin",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("EivorA.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
                      var skin = ModAPI.LoadTexture("EivorB.png");
                                 //get person
                                 var person = Instance.GetComponent<PersonBehaviour>();

                                 //use the helper function to set each texture
                                 //parameters are as follows:
                                 //  skin texture, flesh texture, bone texture, sprite scale
                                 //you can pass "null" to fall back to the original texture
                                 person.SetBodyTextures(skin, null, null, 1);

                                 //change procedural damage colours if they interfere with your texture (rgb 0-255)
                                 person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                                 person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                                 person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                                 person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                                 person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Connor",
                    DescriptionOverride = "A boy blinded by vengeance",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("ConnorA.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
                      var skin = ModAPI.LoadTexture("ConnorB.png");
                                 //get person
                                 var person = Instance.GetComponent<PersonBehaviour>();

                                 //use the helper function to set each texture
                                 //parameters are as follows:
                                 //  skin texture, flesh texture, bone texture, sprite scale
                                 //you can pass "null" to fall back to the original texture
                                 person.SetBodyTextures(skin, null, null, 1);

                                 //change procedural damage colours if they interfere with your texture (rgb 0-255)
                                 person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                                 person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                                 person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                                 person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                                 person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
             ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Alexios",
                    DescriptionOverride = "Brother and sister one satan",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("AlexiosA.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
                      var skin = ModAPI.LoadTexture("AlexiosB.png");
                                 //get person
                                 var person = Instance.GetComponent<PersonBehaviour>();

                                 //use the helper function to set each texture
                                 //parameters are as follows:
                                 //  skin texture, flesh texture, bone texture, sprite scale
                                 //you can pass "null" to fall back to the original texture
                                 person.SetBodyTextures(skin, null, null, 1);

                                 //change procedural damage colours if they interfere with your texture (rgb 0-255)
                                 person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                                 person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                                 person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                                 person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                                 person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Baek",
                    DescriptionOverride = "Medjay of Siwa, Just like Geralt of Rivia ",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("BaekA.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
                      var skin = ModAPI.LoadTexture("BaekB.png");
                                 //get person
                                 var person = Instance.GetComponent<PersonBehaviour>();

                                 //use the helper function to set each texture
                                 //parameters are as follows:
                                 //  skin texture, flesh texture, bone texture, sprite scale
                                 //you can pass "null" to fall back to the original texture
                                 person.SetBodyTextures(skin, null, null, 1);

                                 //change procedural damage colours if they interfere with your texture (rgb 0-255)
                                 person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                                 person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                                 person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                                 person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                                 person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Guard 1",
                    DescriptionOverride = "Guard from the first part",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("Guard 1A.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
                      var skin = ModAPI.LoadTexture("Guard 1B.png");
                                 //get person
                                 var person = Instance.GetComponent<PersonBehaviour>();

                                 //use the helper function to set each texture
                                 //parameters are as follows:
                                 //  skin texture, flesh texture, bone texture, sprite scale
                                 //you can pass "null" to fall back to the original texture
                                 person.SetBodyTextures(skin, null, null, 1);

                                 //change procedural damage colours if they interfere with your texture (rgb 0-255)
                                 person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                                 person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                                 person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                                 person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                                 person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Guard 2",
                    DescriptionOverride = "Guard from the second part",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("Guard 2A.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
                      var skin = ModAPI.LoadTexture("Guard 2B.png");
                                 //get person
                                 var person = Instance.GetComponent<PersonBehaviour>();

                                 //use the helper function to set each texture
                                 //parameters are as follows:
                                 //  skin texture, flesh texture, bone texture, sprite scale
                                 //you can pass "null" to fall back to the original texture
                                 person.SetBodyTextures(skin, null, null, 1);

                                 //change procedural damage colours if they interfere with your texture (rgb 0-255)
                                 person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                                 person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                                 person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                                 person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                                 person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Guard 3",
                    DescriptionOverride = "Guard from the third part",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("Guard 3A.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
                      var skin = ModAPI.LoadTexture("Guard 3B.png");
                                 //get person
                                 var person = Instance.GetComponent<PersonBehaviour>();

                                 //use the helper function to set each texture
                                 //parameters are as follows:
                                 //  skin texture, flesh texture, bone texture, sprite scale
                                 //you can pass "null" to fall back to the original texture
                                 person.SetBodyTextures(skin, null, null, 1);

                                 //change procedural damage colours if they interfere with your texture (rgb 0-255)
                                 person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                                 person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                                 person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                                 person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                                 person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
             //Rapier
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),
                    NameOverride = "Rapier",
                    NameToOrderByOverride = "Rapier Guard 2",
                    DescriptionOverride = "A reliable broad-bladed rapier",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("rapierthumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("rapier.png", 1f);
						Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Ezio",
                    DescriptionOverride = "Top Person",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("EzioA.png"), //Doesn't exist yet!
                    AfterSpawn = (Instance) =>
                    {
                      var skin = ModAPI.LoadTexture("EzioB.png");
                                 //get person
                                 var person = Instance.GetComponent<PersonBehaviour>();

                                 //use the helper function to set each texture
                                 //parameters are as follows:
                                 //  skin texture, flesh texture, bone texture, sprite scale
                                 //you can pass "null" to fall back to the original texture
                                 person.SetBodyTextures(skin, null, null, 1);

                                 //change procedural damage colours if they interfere with your texture (rgb 0-255)
                                 person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                                 person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                                 person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                                 person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                                 person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
  // Ezio Yatagan
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Knife"), //item to derive from
        NameOverride = "Ezio Yatagan", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "It is Ezio Yatagan.", //new item description
        CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("rengoku.png"); 
					Instance.FixColliders();
        }
    }
 );
 // AltairSwords
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Knife"), //item to derive from
        NameOverride = "Altair Sword", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "It is Altair Sword.", //new item description
        CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("AltairSwords.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AltairSword.png"); 
					Instance.FixColliders();
        }
    }
);
       ModAPI.Register(
             new Modification()
            {
            OriginalItem = ModAPI.FindSpawnable("Sword"),
            NameOverride = "Tomahawk",
           DescriptionOverride = "Tomahawk boy named Connor ",
          CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
          ThumbnailOverride = ModAPI.LoadSprite("TomahawkA.png"),
               AfterSpawn = (Instance) =>
            {
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("TomahawkB.png");
          Instance.FixColliders();          
           }
       } 
   ); 
  //HiddenBlade
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),
                    NameOverride = "HiddenBlade",
                    NameToOrderByOverride = "g",
                    DescriptionOverride = "A HiddenBlade.",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("HiddenBladeprew.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("HiddenBlade.png");
						Instance.FixColliders();
                    }
                }
            ); 
           //Sword - Pistol
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),
                    NameOverride = "Sword - Pistol",
                    NameToOrderByOverride = "Given for contracts with Assassins Creed 4",
                    DescriptionOverride = "Given for contracts with Assassins Creed 4 ",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("SwordPistolA.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SwordPistolB.png", 1f);
						Instance.FixColliders();
                    }
                }
            ); 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),
                    NameOverride = "Hidden blade",
                    NameToOrderByOverride = "Hidden Blade Retractable BETA",
                    DescriptionOverride = "hidden blade of the assassins, retractable blade, unfinished ",
                    CategoryOverride = ModAPI.FindCategory("Assasin's Creed Beta"),
                    ThumbnailOverride = ModAPI.LoadSprite("RetractableSwordThumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("RetractableSword2.png");
                        Instance.FixColliders();

                        var SwordBehaviour = Instance.GetOrAddComponent<SwordBehaviour>();

                        var Sword = Instance.GetComponent<SwordBehaviour>();

                        Sword.A = ModAPI.LoadSprite("RetractableSwordOff.png");
                        Sword.B = ModAPI.LoadSprite("RetractableSwordOn.png");
                        Instance.AddComponent<UseEventTrigger>().Action = () => {
                        Instance.FixColliders();
                        };

                    }
                }
            );
        }
    }
    
    class SwordBehaviour : MonoBehaviour
    {
       private void Start()
       {
           this.renderer = gameObject.GetComponent<SpriteRenderer>();
           UpdateState();
       }
       void UpdateState()
       {
           if(this.Activated)
           {
               renderer.sprite = B;
           }
           else
           {
               renderer.sprite = A;
           }
       }
       private void Use() {
         if (!base.enabled) {
            return;
         }
         this.SetActivated(!this.Activated);
      }
      private void SetActivated(bool activated) {
         this.Activated = activated;
         UpdateState();
      }

      public bool Activated = false;
      [SkipSerialisation]
      public SpriteRenderer renderer;
      [SkipSerialisation]
      public Sprite A;
      [SkipSerialisation]
      public Sprite B;
              } 
            }             

         